import datetime

import pytz
import redis

from es_tool import es_insert_device_info
from tool import (get_user_portrait_tag3_from_redis, get_user_portrait_tag3_with_score)

redis_client = redis.StrictRedis.from_url("redis://:ReDis!GmTx*0aN6@172.16.40.133:6379")
redis_client2 = redis.StrictRedis.from_url("redis://:ReDis!GmTx*0aN9@172.16.40.173:6379")
redis_client3 = redis.StrictRedis.from_url("redis://:ReDis!GmTx*0aN12@172.16.40.164:6379")
redis_client4 = redis.StrictRedis.from_url("redis://:XfkMCCdWDIU%ls$h@172.16.50.145:6379")


def user_portrait_scan_info():
    try:
        round = 0
        all_count = 0
        just_projects_count = 0
        portrait_no_candidates_count = 0
        keys = "doris:user_portrait:tag3:device_id:*"
        cur, results = redis_client2.scan(0, keys, 3000)
        while cur != 0:
            round += 1
            print("round: " + str(round))
            cur, results = redis_client2.scan(cur, keys, 3000)
            for key in results:
                key = str(key, "utf-8")
                device_id = key.split(":")[-1]
                all_count += 1

                print(str(all_count) + ": " + device_id)
                write_to_es(device_id)

        print("all count: " + str(all_count))
        print("just projects portrait: " + str(just_projects_count))
        print("just portrait no candidates: " + str(portrait_no_candidates_count))
        print("scan done " + str(datetime.datetime.now()))
    except Exception as e:
        print(e)


def _dict_to_name_score(d):
    res = []
    new_d = sorted(d.items(), key=lambda x: x[1], reverse=True)
    for (k, v) in new_d:
        res.append({"name": k, "score": float(v)})
    return res


def write_to_es(device_id):
    body = {}
    d = get_user_portrait_tag3_with_score(device_id)
    if d:
        first_demands_d = d.get("first_demands", {})
        second_demands_d = d.get("second_demands", {})
        first_positions_d = d.get("first_positions", {})
        second_positions_d = d.get("second_positions", {})
        first_solutions_d = d.get("first_solutions", {})
        second_solutions_d = d.get("second_solutions", {})
        projects_d = d.get("projects", {})
        anecdote_tags = d.get("anecdote_tags", {})

        body["device_id"] = device_id
        body["last_modified"] = datetime.datetime.strftime(datetime.datetime.now(pytz.timezone("Asia/Shanghai")),
                                                           "%Y-%m-%dT%H:%M:%S.%f")[:-7] + "Z"
        body["first_demands"] = _dict_to_name_score(first_demands_d)
        body["second_demands"] = _dict_to_name_score(second_demands_d)
        body["first_positions"] = _dict_to_name_score(first_positions_d)
        body["second_positions"] = _dict_to_name_score(second_positions_d)
        body["first_solutions"] = _dict_to_name_score(first_solutions_d)
        body["second_solutions"] = _dict_to_name_score(second_solutions_d)
        body["projects"] = _dict_to_name_score(projects_d)
        body["anecdote_tags"] = _dict_to_name_score(anecdote_tags)
        es_insert_device_info(device_id, body)


if __name__ == "__main__":
    # device_id = "androidid_a25a1129c0b38f7b"
    # write_to_es(device_id)

    user_portrait_scan_info()

    print("done: " + str(datetime.datetime.now()))
